package ms.warpzone.warppay.data;


import java.util.ArrayList;
import java.util.List;

import ms.warpzone.warppay.data.models.rest.RestCategory;
import ms.warpzone.warppay.data.models.rest.RestProduct;
import ms.warpzone.warppay.data.models.rest.RestTransaction;
import ms.warpzone.warppay.data.models.rest.RestUser;
import retrofit.Call;
import retrofit.http.Body;
import retrofit.http.GET;
import retrofit.http.POST;
import retrofit.http.PUT;
import retrofit.http.Path;

public interface RestService {

    @GET("users/{user}")
    Call<RestUser> getSingleUser(@Path("user") String userid);

    @GET("users/")
    Call<List<RestUser>> getAllUser();

    @POST("users/")
    Call<RestUser> addUser(@Body RestUser user);

    @PUT("users/{userid}/")
    Call<RestUser> saveUser(@Path("userid") String uid, @Body RestUser user);

    @GET("products/")
    Call<List<RestProduct>> getAllProducts();

    @GET("categories/")
    Call<List<RestCategory>> getAllCategories();

    @PUT("transactions/{userid}/")
    Call<Void> saveTransaction(@Path("userid") String uid, @Body ArrayList<RestTransaction> transaction);

    @PUT("products/{productid}/barcode/")
    Call<Void> saveBarcode(@Path("productid") int pid, @Body RestProduct product);
}