package ms.warpzone.warppay.data;

import android.util.Log;

import com.activeandroid.query.Select;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import ms.warpzone.warppay.data.models.local.Category;
import ms.warpzone.warppay.data.models.local.Product;
import ms.warpzone.warppay.data.models.local.Setting;
import ms.warpzone.warppay.data.models.local.User;
import ms.warpzone.warppay.data.models.rest.RestCategory;
import ms.warpzone.warppay.data.models.rest.RestProduct;
import ms.warpzone.warppay.data.models.rest.RestUser;

public class SQLiteService {

    private static SQLiteService instance;
    private SQLiteService() {}

    public static SQLiteService getInstance () {
        if (SQLiteService.instance == null)
            SQLiteService.instance = new SQLiteService();
        return SQLiteService.instance;
    }


    public void saveSetting(String key, String value) {
        Setting.setSetting(key, value);
    }

    public String getSetting(String key) {
        return this.getSetting(key, "");
    }

    public String getSetting(String key, String defaultValue) {
        String value = Setting.getSetting(key);
        if(value == null) {
            return defaultValue;
        }
        return value;
    }

    public List<User> refreshUserData(List<RestUser> u) {
        User.deleteAll();
        List<User> ret_val = new ArrayList<>();
        if(u != null) {
            for (RestUser anU : u) {
                User usr = anU.toLocalUser();
                usr.save();
                ret_val.add(usr);
            }
        }
        return ret_val;
    }

    public List<Category> refreshCategoryData(List<RestCategory> c) {
        Category.deleteAll();
        List<Category> ret_val = new ArrayList<>();
        if(c!=null) {
            for (RestCategory category : c) {
                Category cat = category.toLocalCategory();
                cat.save();
                ret_val.add(cat);
            }
        }
        return ret_val;
    }

    public List<Product> refreshProductData(List<RestProduct> body) {
        Product.deleteAll();
        List<Product> ret_val = new ArrayList<>();
        if (body != null) {
            for (RestProduct anU : body) {
                Product prod = anU.toLocalProduct();
                prod.save();
                ret_val.add(prod);
            }
        }
        return ret_val;
    }


}
