package ms.warpzone.warppay.data.models.rest;

import java.math.BigDecimal;

import ms.warpzone.warppay.data.models.local.Product;

public class RestProduct {


    private int id;
    private String name;
    private String category;
    private String barcode;
    private BigDecimal price_vk;
    private int stock_count;
    private float position;

    public RestProduct() {
        super();
    }

    public RestProduct(int id, String name, String category,String barcode, BigDecimal price_vk, int stock_count, float position) {
        this.id = id;
        this.name = name;
        this.category = category;
        this.barcode = barcode;
        this.price_vk = price_vk;
        this.stock_count = stock_count;
        this.position = position;
    }

    public int getId() {
        return this.id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getCategory() {
        return category;
    }

    public void setCategory(String category) {
        this.category = category;
    }

    public BigDecimal getPrice() {
        return price_vk;
    }

    public void setPrice(BigDecimal price) {
        this.price_vk = price_vk;
    }

    public int getCount() {
        return stock_count;
    }

    public void setCount(int stock_count) {
        this.stock_count = stock_count;
    }

    public Product toLocalProduct() {
        Product p = new Product();
        p.setPid(this.id);
        p.setName(this.name);
        p.setCategory(this.category);
        p.setBarcode(this.barcode);
        p.setPrice(this.price_vk);
        p.setCount(this.stock_count);
        p.setPosition(this.position);
        return p;
    }

    public static RestProduct fromLocalProduct(Product product) {
        RestProduct restProduct = new RestProduct();
        restProduct.setId(product.getPid());
        restProduct.setName(product.getName());
        restProduct.setCategory(product.getCategory());
        restProduct.setBarcode(product.getBarcode());
        restProduct.setCount(product.getCount());
        restProduct.setPrice(product.getPrice());
        restProduct.setPosition(product.getPosition());
        return restProduct;
    }

    public void setBarcode(String barcode) {
        this.barcode = barcode;
    }

    public String getBarcode() {
        return barcode;
    }

    public float getPosition() {
        return position;
    }

    public void setPosition(float position) {
        this.position = position;
    }
}
