package ms.warpzone.warppay.dialogs;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Handler;

import ms.warpzone.warppay.R;

public class NotificationDialog  {

    AlertDialog.Builder builder;
    AlertDialog dialog;
    private String message;

    public NotificationDialog(Context context, String title, String message) {
        this.builder = new AlertDialog.Builder(context);
        this.builder.setTitle(title);
        this.builder.setMessage(message);
    }

    public NotificationDialog(Context context) {
        this.builder = new AlertDialog.Builder(context);
    }

    public AlertDialog.Builder getBuilder() {
        return this.builder;
    }

    public void show() {
        this.show(0);
    }

    public void setWarning() {
        this.builder.setIcon(R.drawable.ic_dialog_alert_holo_light);
        this.builder.setCancelable(false);
        this.builder.setTitle("WARNING");
    }
    public void show(int timeout) {
        this.dialog = this.builder.create();
        this.dialog.show();
        if(timeout > 0) {
            this.enableAutoDismiss(timeout);
        }
    }

    public void enableAutoDismiss(int time){
        final Handler handler = new Handler();
        final Runnable runnable = new Runnable() {
            @Override
            public void run() {
                AlertDialog alertDialog = NotificationDialog.this.dialog;
                if (alertDialog != null && alertDialog.isShowing()) {
                    alertDialog.dismiss();
                }
            }
        };

        this.dialog.setOnDismissListener(new DialogInterface.OnDismissListener() {
            @Override
            public void onDismiss(DialogInterface dialog) {
                handler.removeCallbacks(runnable);
            }
        });

        handler.postDelayed(runnable, time);
    }

    public void setMessage(String message) {
        this.builder.setMessage(message);
    }

    public void dismiss() {
        if(this.dialog != null) {
            this.dialog.dismiss();
        }
    }

    public AlertDialog getDialog() {
        return dialog;
    }
}
